#include "UI.h"

UI::UI(int *lastKey) {
	this->lastKey = lastKey;
}

const std::string UI::NORMAL_WINDOW = "Normal";
const std::string UI::DEBUG_WINDOW = "Debug";

void UI::render() {
	if (state < frames.size()) {
		frames.resize(state + 1);
	}
	state = 0;
	cv::imshow(UI::NORMAL_WINDOW, frames[0]);
	if (debug) {
		cv::imshow(UI::DEBUG_WINDOW, frames[debugFrame]);
	}

	if (*lastKey == 100) {
		debug = !debug;
		if (debug == true) {
			cv::imshow(UI::DEBUG_WINDOW, frames[debugFrame]);
			for (unsigned i = 0; i < UIListeners.size(); i++) {
				UIListeners[i]->componentSetup();
			}
		} else {
			cv::destroyWindow(UI::DEBUG_WINDOW);
		}
	}

	if (debug) {
		if (*lastKey == 110) {
			nextDebugFrame();
		}
	}
}

cv::Mat* UI::nextFrame() {
	state++;
	if (state + 1 > frames.size()) {
		frames.push_back(cv::Mat { });
	}
	return &(frames[state]);
}

cv::Mat* UI::currentFrame(int offset) {
	return &(frames[state + offset]);
}

void UI::nextDebugFrame() {
	debugFrame++;
	if (debugFrame > frames.size() - 1) {
		debugFrame = 0;
	}
}

void UI::setOriginalFrame(cv::Mat frame) {
	frames[0] = frame;
}

cv::Mat* UI::originalFrame() {
	return &frames[0];
}

UI::~UI() {
}
